-- Gamestates and Controls

gamestates = { }

gamestates.test = {
  bindings = {
    -- Presses
    down = function() player.f.move(nil, 1) end,
    up = function() player.f.move(nil, -1) end,
    right = function() player.f.move(1, nil) end,
    left = function() player.f.move(-1, nil) end,
    killsplash = function() log("Skipped splash") splashoff = true splashTextAlpha = 255 newMap("test") end,
    toggledebug = function() debugging = not debugging log("Debugging: ".. tostring(debugging)) end,
    quit = function() le.quit() end,
    fullscreen = function()
      lw.setFullscreen(not lw.getFullscreen())
    end,
    
    -- Releases
    downr = function() player.f.move(nil, -1) end,
    upr = function() player.f.move(nil, 1) end,
    rightr = function() player.f.move(-1, nil) end,
    leftr = function() player.f.move(1, nil) end,
  },
  keys = {
    down = "down",
    up = "up",
    left = "left",
    right = "right",
    w = "killsplash",
    d = "toggledebug",
    escape = "quit",
    f12 = "fullscreen",
  },
  keysreleased = {
    down = "downr",
    up = "upr",
    left = "leftr",
    right = "rightr",
  },
  buttons = {
    
  },
  buttonsreleased = { }
}

state = gamestates.test

function inputHandler(input)
  local action = state.bindings[input]
  if action then return action() end
end

function love.mousemoved(x, y, dx, dy)
  
end

function love.mousepressed(x, y, button, istouch)
  if istouch then return end
  mbdown = button
end

function love.mousereleased(x, y, button, istouch)
  if istouch then return end
  mbdown = nil
end

function love.touchmoved(id, x, y, dx, dy, pressure)
  if not (mobile or touchCon) then return end
  local binding
  if moving_id == id and x > 114 and x < 174 and y > winH - 210 and y < winH - 160 then binding = state.keys["up"] end
  if moving_id == id and x > 114 and x < 174 and y > winH - 100 and y < winH - 50 then binding = state.keys["down"] end
  if moving_id == id and x > 64 and x < 140 and y > winH - 160 and y < winH - 100 then binding = state.keys["left"] end
  if moving_id == id and x > 148 and x < 234 and y > winH - 160 and y < winH - 100 then binding = state.keys["right"] end
  return inputHandler(binding)
end

function love.touchpressed(id, x, y, dx, dy, pressure)
  if not (mobile or touchCon) then return end
  inputMethod = "touch"
  local binding
  if x > 114 and x < 174 and y > winH - 210 and y < winH - 160 then moving_id = id binding = state.keys["up"] end
  if x > 114 and x < 174 and y > winH - 100 and y < winH - 50 then moving_id = id binding = state.keys["down"] end
  if x > 64 and x < 140 and y > winH - 160 and y < winH - 100 then moving_id = id binding = state.keys["left"] end
  if x > 148 and x < 234 and y > winH - 160 and y < winH - 100 then moving_id = id binding = state.keys["right"] end
  return inputHandler(binding)
end

function love.touchreleased(id, x, y, dx, dy, pressure)
  if not (mobile or touchCon) then return end
  local binding
  if x > 114 and x < 174 and y > winH - 210 and y < winH - 160 then binding = state.keysreleased["up"] end
  if x > 114 and x < 174 and y > winH - 100 and y < winH - 50 then binding = state.keysreleased["down"] end
  if x > 64 and x < 140 and y > winH - 160 and y < winH - 100 then binding = state.keysreleased["left"] end
  if x > 148 and x < 234 and y > winH - 160 and y < winH - 100 then binding = state.keysreleased["right"] end
  if x > winW - 160 and x < winW - 80 and y > winH - 240 and y < winH - 160 then binding = state.keys["x"] end
  if x > winW - 240 and x < winW - 160 and y > winH - 160 and y < winH - 80 then binding = state.keys["z"] end
  return inputHandler(binding)
end

function love.keypressed(key)
  inputMethod = "keyboard"
  local binding = state.keys[key]
  return inputHandler(binding)
end

function love.keyreleased(key)
  local binding = state.keysreleased[key]
  return inputHandler(binding)
end

function love.gamepadpressed(js, button)
  inputMethod = "gamepad"
  local binding = state.buttons[button]
  return inputHandler(binding)
end

function love.gamepadreleased(js, button)
  local binding = state.buttons[button]
  return inputHandler(binding)
end