-- Map sprite handling

player = { }
player.f = { }

function player.f.create()
  player.char = {
    id = "player",
    sprite = lg.newImage("graphics/sprites/bac.png"),
    anim = { },
    x = 16,
    y = 16,
    w = 16,
    h = 16,
    dx = 16,
    dy = 16,
    spd = 50,
    controls = { rl = 0, ud = 0 },
    facing = 'right',
  }
  player.char.grid = anim8.newGrid(player.char.sprite:getWidth() / 4, player.char.sprite:getHeight() / 4, player.char.sprite:getWidth(), player.char.sprite:getHeight())
  player.char.anim.down = anim8.newAnimation(player.char.grid('1-4', 3), 0.2)
  player.char.anim.right = anim8.newAnimation(player.char.grid('1-4', 2), 0.2)
  player.char.anim.up = anim8.newAnimation(player.char.grid('1-4', 1), 0.2)
  player.char.anim.left = anim8.newAnimation(player.char.grid('1-4', 4), 0.2)
  
  world:add(player.char, 16, 16, 16, 16)
end

function player.f.move(nxr, nyr)
  if player ~= nil and player.char ~= nil then
    if nyr == nil then player.char.controls.rl = player.char.controls.rl + nxr end
    if nxr == nil then player.char.controls.ud = player.char.controls.ud + nyr end
  end
end

function player.f.update(dt)
  if player == nil or player.char == nil then return end
  
  if player.char.x % 16 == 0 and player.char.y % 16 == 0 then
    player.char.dx, player.char.dy, cols, len = world:move(player.char, player.char.dx + player.char.controls.rl * 16, player.char.dy + player.char.controls.ud * 16)
  end
  if player.char.x < player.char.dx then
    player.char.facing = 'right'
    player.char.x = player.char.x + player.char.spd * dt
    if player.char.x > player.char.dx then
      player.char.x = player.char.dx
    end
  elseif player.char.x > player.char.dx then
    player.char.facing = 'left'
    player.char.x = player.char.x - player.char.spd * dt
    if player.char.x < player.char.dx then
      player.char.x = player.char.dx
    end
  end
  if player.char.y < player.char.dy then
    player.char.facing = 'down'
    player.char.y = player.char.y + player.char.spd * dt
    if player.char.y > player.char.dy then
      player.char.y = player.char.dy
    end
  elseif player.char.y > player.char.dy then
    player.char.facing = 'up'
    player.char.y = player.char.y - player.char.spd * dt
    if player.char.y < player.char.dy then
      player.char.y = player.char.dy
    end
  end
  
  if player.char.x ~= player.char.dx or player.char.y ~= player.char.dy then
    for i, a in pairs(player.char.anim) do
      a:update(dt)
    end
  end
end

function player.f.draw()
  if player.char == nil then return end
  --lg.rectangle('line', player.char.x, player.char.y, player.char.w, player.char.h)
  player.char.anim[player.char.facing]:draw(player.char.sprite, player.char.x, player.char.y - 2)
end